<template>
  <div class="-grid-2 _container">
    <div>
      <h2>{{ $t('js.team_mates.team_mates') }}</h2>

      <gpa-team-mate v-for="teamMate in teamMates" :key="teamMate.id" :team-mate="teamMate" />
    </div>

    <div v-if="isOwner">
      <h2>{{ $t('js.team_mates.complete_team') }}</h2>

      <h3>{{ $t('js.team_mates.search_by_email') }}</h3>
      <gpa-search-users :ignored-ids="teamMatesIds"
                        search-field="email"
                        @choose="handleUserSelection" />

      <h3>{{ $t('js.team_mates.search_by_username') }}</h3>
      <gpa-search-users :ignored-ids="teamMatesIds"
                        search-field="username"
                        @choose="handleUserSelection" />
    </div>
  </div>
</template>

<script>
import GpaTeamMate from './TeamMates/_TeamMate.vue'
import GpaSearchUsers from './Users/_Search.vue'
import Toaster from '../../../tools/Toaster'

export default {
  name: 'GpaTeam',
  components: { GpaSearchUsers, GpaTeamMate },
  data () {
    return {
      teamMatesSearchResults: [],
      loadingUsers: false,
      inputs: {
        username: '',
      },
    }
  },
  computed: {
    teamMates () { return this.$store.getters.teamMates },
    teamMatesIds () { return this.teamMates.map(t => t.user.id) },
    isOwner () {
      const map = this.$store.getters.map(parseInt(this.$route.params.mapId, 10))
      return map && map.isOwned
    },
  },
  methods: {
    handleUserSelection (user) {
      this.$store.dispatch('createTeamMate', {
        map_id: parseInt(this.$route.params.mapId, 10),
        user_id: user.id,
      }).then(() => {
        Toaster.success(this.$t('js.team_mates.successfully_invited', { name: user.username }))
      })
    },
  },
}
</script>
